package net.zmobile.ui;

import java.util.Vector;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;

import net.zmobile.ge.ZPoint;
import net.zmobile.ge.ZRect;
import net.zmobile.ui.layout.ZFillLayout;

public class ZMenu extends ZContainer {

	public final static byte LEFT_KEY = 0;
	public final static byte RIGTH_KEY = 1;
	byte _type = LEFT_KEY;

	Vector leftVector = new Vector();
	Vector rightVector = new Vector();
	public ZMenu() {
		this._x = 0;
		this._y = 0;
		this._w = 100;
		this._h = Font.getDefaultFont().getHeight();
		this.setLayout(new ZFillLayout(ZFillLayout.V_LAYOUT));
	}

	public void draw(Graphics g) {
		_h = _components.size()*Font.getDefaultFont().getHeight();
		System.out.println("asfasdf"+_components.size()+":"+_h);
		g.setClip(_x-1, _y-1, _w+2, _h+2);
		g.setColor(0xffffff);
		g.fillRect(_x, _y, _w, _h);
		super.draw(g);
		g.setColor(0x0);
		
		g.setClip(_x-1, _y-1, _w+2, _h+2);
		System.out.println(_x+":"+_y+":"+_w+":"+_h);
		g.drawRect(_x, _y, _w, _h);
		g.drawLine(_x, _y, _w, _h);
		this.setFoucus(true);
	}

	public void append(String title, byte type) {
		if(LEFT_KEY==type){
			leftVector.addElement((new ZMenuItem(title, type)));
		}else{
			rightVector.addElement((new ZMenuItem(title, type)));			
		}
		_h += Font.getDefaultFont().getHeight();
		resize();
	}

	public void show(byte type) {
		_type = type;
		resize();
		if(!ZForm.uiStack.contains(this))ZForm.uiStack.push(this);
	}

	class ZMenuItem extends ZComponent {
		String title = "";
		public byte _type = 0;

		public ZMenuItem(String title, byte type) {
			this.title = title;
			_type = type;
		}

		public void draw(Graphics g) {
			Font font = g.getFont();
			if (this.isFoucus()) {
				g.setColor(0, 0, 255);
				g.fillRect(_x, _y , _w,_h);
				g.setColor(255, 255, 255);
				g.drawString(title, _x + _w / 2 - font.stringWidth(title) / 2, _y + _h / 2 - font.getHeight() / 2, Graphics.TOP | Graphics.LEFT);

			} else {
				g.drawString(title, _x + _w / 2 - font.stringWidth(title) / 2, _y + _h / 2 - font.getHeight() / 2, Graphics.TOP | Graphics.LEFT);
			}
		}

		public void firePointRelease(ZPoint point) {
			super.firePointRelease(point);
			ZRect rect = new ZRect(_x,_y,_w,_h);
			if(rect.contains(point)){
				ZForm.uiStack.pop();
			}
			
		}

		public void drawStatus(Graphics g) {

		}

		public void resetSize() {
			// TODO Auto-generated method stub
			
		}

	}

	public void resize() {
		if(LEFT_KEY==_type){
			this._components = leftVector;
		}else{
			this._components = rightVector;			
		}
		_h = _components.size()*Font.getDefaultFont().getHeight();
		super.resize();
	}

	public void setBounds(int x, int y, int w, int h) {
		super.setBounds(x, y, w, h);
		resize();
	};
}
