package net.zmobile.ui;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;

import net.zmobile.ZMobile;

public class ZTextBox extends ZComponent {

	public ZTextBox(String string) {
		this.setText(string);
		resetSize();
	}

	public void draw(Graphics g) {
		g.setColor(0xffffff);
		g.fillRect(_x + ZMobile.GRAP, _y + ZMobile.GRAP, _w - 2 * ZMobile.GRAP, _h - 2
				* ZMobile.GRAP);

		g.setColor(0);
		int grap = ZMobile.GRAP;
		g.drawRect(_x + grap, _y + grap, _w - 2 * grap, _h - 2 * grap);
	}

	public void drawStatus(Graphics g) {
		if (this.isFoucus) {
			g.setColor(0x0000ff);
		}else if(this.isPressed){
			g.setColor(0x00ff00);
		}else{
			return;
		}
		g.drawRect(_x + ZMobile.GRAP, _y + ZMobile.GRAP, _w - 2
				* ZMobile.GRAP, _h - 2 * ZMobile.GRAP);
		g.drawRect(_x + ZMobile.GRAP + 1, _y + ZMobile.GRAP + 1, _w - 2
				* ZMobile.GRAP - 2, _h - 2 * ZMobile.GRAP - 2);
	}

	public void resetSize() {
		this._w = Font.getDefaultFont().stringWidth(_text);
		this._h = Font.getDefaultFont().getHeight();
	}

}
